From 1ea610b522300714bf4073545c45cf92dbb601b3 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?H=C3=A9ctor=20Daniel=20Cabrera?= <logan@fedoraproject.org>
Date: Thu, 15 Apr 2010 08:40:37 -0400
Subject: [PATCH] Updating ES translation

---
 src/po/es.po |  271 +++++++++++++++++++++++++++------------------------------
 1 files changed, 128 insertions(+), 143 deletions(-)

diff --git a/src/po/es.po b/src/po/es.po
index 16c2ff950b1250038da7ae8343f56eef93a736bc..621ed6c9f0c412c89692b6fab809a98faf5ed144 100644
--- a/src/po/es.po
+++ b/src/po/es.po
@@ -9,7 +9,7 @@ msgstr ""
 "Project-Id-Version: sss_daemon 0.4.0\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
 "POT-Creation-Date: 2010-04-12 09:33-0400\n"
-"PO-Revision-Date: 2010-03-15 11:40-0300\n"
+"PO-Revision-Date: 2010-04-14 15:50-0300\n"
 "Last-Translator: Héctor Daniel Cabrera <logan@fedoraproject.org>\n"
 "Language-Team: Fedora Spanish <trans-es@lists.fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
@@ -41,8 +41,7 @@ msgstr "Comando para iniciar el servicio"
 
 #: config/SSSDConfig.py:44
 msgid "Number of times to attempt connection to Data Providers"
-msgstr ""
-"Número de veces que debe intentar la conexión con los Proveedores de Datos"
+msgstr "Número de veces que debe intentar la conexión con los Proveedores de Datos"
 
 #: config/SSSDConfig.py:47
 msgid "SSSD Services to start"
@@ -58,14 +57,11 @@ msgstr "Tiempo máximo para los mensajes enviados a través de SBUS"
 
 #: config/SSSDConfig.py:50
 msgid "Regex to parse username and domain"
-msgstr ""
-"Expresión regular para analizar sintácticamente el nombre de usuario y "
-"dominio"
+msgstr "Expresión regular para analizar sintácticamente el nombre de usuario y dominio"
 
 #: config/SSSDConfig.py:51
 msgid "Printf-compatible format for displaying fully-qualified names"
-msgstr ""
-"Formato compatible con printf para mostrar nombres completamente calificados"
+msgstr "Formato compatible con printf para mostrar nombres completamente calificados"
 
 #: config/SSSDConfig.py:54
 msgid "Enumeration cache timeout length (seconds)"
@@ -73,8 +69,7 @@ msgstr "Tiempo máximo (segundos) del caché de enumeración"
 
 #: config/SSSDConfig.py:55
 msgid "Entry cache background update timeout length (seconds)"
-msgstr ""
-"Tiempo máximo (segundos) de la entrada de caché a actualizar en segundo plano"
+msgstr "Tiempo máximo (segundos) de la entrada de caché a actualizar en segundo plano"
 
 #: config/SSSDConfig.py:56
 msgid "Negative cache timeout length (seconds)"
@@ -98,21 +93,15 @@ msgstr "El valor del campo contraseña que el proveedor NSS debe devolver"
 
 #: config/SSSDConfig.py:63
 msgid "How long to allow cached logins between online logins (days)"
-msgstr ""
-"Por cuánto tiempo permitir ingresos cacheados entre ingresos en línea (días)"
+msgstr "Por cuánto tiempo permitir ingresos cacheados entre ingresos en línea (días)"
 
 #: config/SSSDConfig.py:64
 msgid "How many failed logins attempts are allowed when offline"
-msgstr ""
-"Cuantos intentos de ingreso fallidos se permiten cuando está desconectado"
+msgstr "Cuantos intentos de ingreso fallidos se permiten cuando está desconectado"
 
 #: config/SSSDConfig.py:65
-msgid ""
-"How long (minutes) to deny login after offline_failed_login_attempts has "
-"been reached"
-msgstr ""
-"Cuántos minutos se denegará el ingreso después de que se alcance el máximo "
-"de ingresos fallidos offline_failed_login_attempts"
+msgid "How long (minutes) to deny login after offline_failed_login_attempts has been reached"
+msgstr "Cuántos minutos se denegará el ingreso después de que se alcance el máximo de ingresos fallidos offline_failed_login_attempts"
 
 #: config/SSSDConfig.py:68
 msgid "Identity provider"
@@ -163,11 +152,8 @@ msgid "Entry cache timeout length (seconds)"
 msgstr "Tiempo máximo de una entrada del caché (segundos)"
 
 #: config/SSSDConfig.py:82
-msgid ""
-"Restrict or prefer a specific address family when performing DNS lookups"
-msgstr ""
-"Restringir o preferir una familia de direcciones específica, cuando se "
-"realicen búsquedas DNS"
+msgid "Restrict or prefer a specific address family when performing DNS lookups"
+msgstr "Restringir o preferir una familia de direcciones específica, cuando se realicen búsquedas DNS"
 
 #: config/SSSDConfig.py:83
 msgid "How long to keep cached entries after last successful login (days)"
@@ -185,11 +171,13 @@ msgstr "Dirección del servidor IPA"
 msgid "IPA client hostname"
 msgstr "Nombre de equipo del cliente IPA"
 
-#: config/SSSDConfig.py:91 config/SSSDConfig.py:120
+#: config/SSSDConfig.py:91
+#: config/SSSDConfig.py:120
 msgid "Kerberos server address"
 msgstr "Dirección del servidor Kerberos"
 
-#: config/SSSDConfig.py:92 config/SSSDConfig.py:121
+#: config/SSSDConfig.py:92
+#: config/SSSDConfig.py:121
 msgid "Kerberos realm"
 msgstr "Reinado Kerberos"
 
@@ -219,9 +207,7 @@ msgstr "El principal del servicio de cambio de contraseña"
 
 #: config/SSSDConfig.py:103
 msgid "Server where the change password service is running if not on the KDC"
-msgstr ""
-"El servidor en donde está ejecutándose el servicio de modificación de "
-"contraseña, en caso de no ser KDC. "
+msgstr "El servidor en donde está ejecutándose el servicio de modificación de contraseña, en caso de no ser KDC. "
 
 #: config/SSSDConfig.py:106
 msgid "ldap_uri, The URI of the LDAP server"
@@ -260,13 +246,12 @@ msgid "Length of time between attempts to reconnect while offline"
 msgstr "Tiempo entre intentos de reconexión cuando esté fuera de línea"
 
 #: config/SSSDConfig.py:115
-#, fuzzy
 msgid "File that contains CA certificates"
-msgstr "archivo que contiene los certificados CA"
+msgstr "Archivo que contiene los certificados CA"
 
 #: config/SSSDConfig.py:116
 msgid "Path to CA certificate directory"
-msgstr ""
+msgstr "Ruta hacia un directorio certificado CA"
 
 #: config/SSSDConfig.py:117
 msgid "Require TLS certificate verification"
@@ -301,9 +286,8 @@ msgid "Length of time between enumeration updates"
 msgstr "Tiempo en segundos entre las actualizaciones de enumeración"
 
 #: config/SSSDConfig.py:129
-#, fuzzy
 msgid "Require TLS for ID lookups"
-msgstr "Requiere TLS para búsquedas de ID, falso"
+msgstr "Requiere TLS para búsquedas de ID"
 
 #: config/SSSDConfig.py:130
 msgid "Base DN for user lookups"
@@ -410,38 +394,32 @@ msgid "sssd must be run as root\n"
 msgstr "sssd debe ejecutarse como root\n"
 
 #: monitor/monitor.c:2252
-msgid ""
-"nscd socket was detected.  As nscd caching capabilities may conflict with "
-"SSSD, it is recommended to not run nscd in parallel with SSSD\n"
-msgstr ""
-"Ha sido detectado un socket nscd. Debido a que las capacidades de cacheo de "
-"nscd pueden entrar en conflicto con SSSD, se recomienda no ejecutar nscd en "
-"forma paralalea con SSSD\n"
+msgid "nscd socket was detected.  As nscd caching capabilities may conflict with SSSD, it is recommended to not run nscd in parallel with SSSD\n"
+msgstr "Ha sido detectado un socket nscd. Debido a que las capacidades de cacheo de nscd pueden entrar en conflicto con SSSD, se recomienda no ejecutar nscd en forma paralalea con SSSD\n"
 
 #: monitor/monitor.c:2262
 #, c-format
-msgid ""
-"Cannot read config file %s, please check if permissions are 0600 and the "
-"file is owned by root.root\n"
-msgstr ""
-"No es posible leer el archivo de configuración %s, por favor verifique que "
-"los permisos sean 0600, y que su deueño sea root.root\n"
+msgid "Cannot read config file %s, please check if permissions are 0600 and the file is owned by root.root\n"
+msgstr "No es posible leer el archivo de configuración %s, por favor verifique que los permisos sean 0600, y que su deueño sea root.root\n"
 
 #: monitor/monitor.c:2267
 msgid "Cannot load configuration database\n"
-msgstr ""
+msgstr "No es posible cargar base de datos de la configuración\n"
 
-#: providers/krb5/krb5_child.c:916 providers/ldap/ldap_child.c:316
+#: providers/krb5/krb5_child.c:916
+#: providers/ldap/ldap_child.c:316
 #: util/util.h:61
 msgid "Debug level"
 msgstr "Nive de depuración"
 
-#: providers/krb5/krb5_child.c:918 providers/ldap/ldap_child.c:318
+#: providers/krb5/krb5_child.c:918
+#: providers/ldap/ldap_child.c:318
 #: util/util.h:65
 msgid "Add debug timestamps"
 msgstr "Agregar marcas de tiempo de depuración"
 
-#: providers/krb5/krb5_child.c:920 providers/ldap/ldap_child.c:320
+#: providers/krb5/krb5_child.c:920
+#: providers/ldap/ldap_child.c:320
 msgid "An open file descriptor for the debug logs"
 msgstr "Un arhivo abierto de descriptor para los registros de depuración"
 
@@ -464,12 +442,12 @@ msgstr ", su contraseña cacheada vencerá el:"
 #: sss_client/pam_sss.c:454
 #, c-format
 msgid "Your password has expired. You have %d grace login(s) remaining."
-msgstr ""
+msgstr "Su contraseña ha expirado. Dispone de %d ingreso(s) excepcionales. "
 
 #: sss_client/pam_sss.c:500
-#, fuzzy, c-format
+#, c-format
 msgid "Your password will expire in %d %s."
-msgstr ", su contraseña cacheada vencerá el:"
+msgstr "Su contraseña expirará en %d %s."
 
 #: sss_client/pam_sss.c:549
 msgid "Offline authentication, authentication is denied until: "
@@ -479,11 +457,13 @@ msgstr "Autenticación fuera de línea, la autenticación se deniega hasta:"
 msgid "System is offline, password change not possible"
 msgstr "El sistema está fuera de línea, no se puede cambiar la contraseña"
 
-#: sss_client/pam_sss.c:606 sss_client/pam_sss.c:619
+#: sss_client/pam_sss.c:606
+#: sss_client/pam_sss.c:619
 msgid "Password change failed. "
 msgstr "Falló el cambio de contraseña."
 
-#: sss_client/pam_sss.c:609 sss_client/pam_sss.c:620
+#: sss_client/pam_sss.c:609
+#: sss_client/pam_sss.c:620
 msgid "Server message: "
 msgstr "Mensaje del servidor:"
 
@@ -507,13 +487,18 @@ msgstr "Contraseña actual: "
 msgid "Password expired. Change your password now."
 msgstr "La contraseña ha expirado. Modifíquela en este preciso momento."
 
-#: tools/sss_useradd.c:92 tools/sss_groupadd.c:41 tools/sss_groupdel.c:43
-#: tools/sss_groupmod.c:42 tools/sss_groupshow.c:620 tools/sss_userdel.c:142
+#: tools/sss_useradd.c:92
+#: tools/sss_groupadd.c:41
+#: tools/sss_groupdel.c:43
+#: tools/sss_groupmod.c:42
+#: tools/sss_groupshow.c:620
+#: tools/sss_userdel.c:142
 #: tools/sss_usermod.c:47
 msgid "The debug level to run with"
 msgstr "Nivel de depuración en que se debe ejecutar"
 
-#: tools/sss_useradd.c:93 tools/sss_usermod.c:48
+#: tools/sss_useradd.c:93
+#: tools/sss_usermod.c:48
 msgid "The UID of the user"
 msgstr "El UID del usuario"
 
@@ -521,15 +506,18 @@ msgstr "El UID del usuario"
 msgid "The GID or group name of the user"
 msgstr "El GID o nombre de grupo del usuario"
 
-#: tools/sss_useradd.c:95 tools/sss_usermod.c:50
+#: tools/sss_useradd.c:95
+#: tools/sss_usermod.c:50
 msgid "The comment string"
 msgstr "La cadena de comentarios"
 
-#: tools/sss_useradd.c:96 tools/sss_usermod.c:51
+#: tools/sss_useradd.c:96
+#: tools/sss_usermod.c:51
 msgid "Home directory"
 msgstr "Directorio de inicio"
 
-#: tools/sss_useradd.c:97 tools/sss_usermod.c:52
+#: tools/sss_useradd.c:97
+#: tools/sss_usermod.c:52
 msgid "Login shell"
 msgstr "Shell de ingreso"
 
@@ -543,19 +531,23 @@ msgstr "Crear el directorio del usuario si no existe"
 
 #: tools/sss_useradd.c:100
 msgid "Never create user's directory, overrides config"
-msgstr ""
-"La opción de nunca crear el directorio del usuario, anula la configurada"
+msgstr "La opción de nunca crear el directorio del usuario, anula la configurada"
 
 #: tools/sss_useradd.c:101
 msgid "Specify an alternative skeleton directory"
 msgstr "Debe especificar un directorio esqueleto alternativo"
 
-#: tools/sss_useradd.c:102 tools/sss_usermod.c:57
+#: tools/sss_useradd.c:102
+#: tools/sss_usermod.c:57
 msgid "The SELinux user for user's login"
-msgstr ""
+msgstr "El usuario de SELinux para el registro del usuario"
 
-#: tools/sss_useradd.c:116 tools/sss_groupadd.c:56 tools/sss_groupdel.c:52
-#: tools/sss_groupmod.c:63 tools/sss_groupshow.c:631 tools/sss_userdel.c:159
+#: tools/sss_useradd.c:116
+#: tools/sss_groupadd.c:56
+#: tools/sss_groupdel.c:52
+#: tools/sss_groupmod.c:63
+#: tools/sss_groupshow.c:631
+#: tools/sss_userdel.c:159
 #: tools/sss_usermod.c:72
 msgid "Error setting the locale\n"
 msgstr "Error al poner la región\n"
@@ -564,30 +556,47 @@ msgstr "Error al poner la región\n"
 msgid "Specify user to add\n"
 msgstr "Especifique el usuario a agregar\n"
 
-#: tools/sss_useradd.c:162 tools/sss_groupadd.c:86 tools/sss_groupdel.c:81
-#: tools/sss_groupmod.c:111 tools/sss_groupshow.c:668 tools/sss_userdel.c:208
+#: tools/sss_useradd.c:162
+#: tools/sss_groupadd.c:86
+#: tools/sss_groupdel.c:81
+#: tools/sss_groupmod.c:111
+#: tools/sss_groupshow.c:668
+#: tools/sss_userdel.c:208
 #: tools/sss_usermod.c:128
 msgid "Error initializing the tools - no local domain\n"
 msgstr "Error al inicializar las herramientas -  no hay dominio local\n"
 
-#: tools/sss_useradd.c:164 tools/sss_groupadd.c:88 tools/sss_groupdel.c:83
-#: tools/sss_groupmod.c:113 tools/sss_groupshow.c:670 tools/sss_userdel.c:210
+#: tools/sss_useradd.c:164
+#: tools/sss_groupadd.c:88
+#: tools/sss_groupdel.c:83
+#: tools/sss_groupmod.c:113
+#: tools/sss_groupshow.c:670
+#: tools/sss_userdel.c:210
 #: tools/sss_usermod.c:130
 msgid "Error initializing the tools\n"
 msgstr "Error al inicializar las herramientas\n"
 
-#: tools/sss_useradd.c:173 tools/sss_groupadd.c:97 tools/sss_groupdel.c:92
-#: tools/sss_groupmod.c:121 tools/sss_groupshow.c:679 tools/sss_userdel.c:219
+#: tools/sss_useradd.c:173
+#: tools/sss_groupadd.c:97
+#: tools/sss_groupdel.c:92
+#: tools/sss_groupmod.c:121
+#: tools/sss_groupshow.c:679
+#: tools/sss_userdel.c:219
 #: tools/sss_usermod.c:139
 msgid "Invalid domain specified in FQDN\n"
 msgstr "Dominio inválido especificado en FQDN\n"
 
-#: tools/sss_useradd.c:182 tools/sss_groupmod.c:143 tools/sss_groupmod.c:170
-#: tools/sss_usermod.c:164 tools/sss_usermod.c:191
+#: tools/sss_useradd.c:182
+#: tools/sss_groupmod.c:143
+#: tools/sss_groupmod.c:170
+#: tools/sss_usermod.c:164
+#: tools/sss_usermod.c:191
 msgid "Internal error while parsing parameters\n"
 msgstr "Error interno al analizar sintácticamente los parámetros.\n"
 
-#: tools/sss_useradd.c:190 tools/sss_usermod.c:172 tools/sss_usermod.c:199
+#: tools/sss_useradd.c:190
+#: tools/sss_usermod.c:172
+#: tools/sss_usermod.c:199
 msgid "Groups must be in the same domain as user\n"
 msgstr "Los grupos deben estar en el mismo dominio que el usuario\n"
 
@@ -600,17 +609,20 @@ msgstr "No se pudo encontrar el grupo %s en el dominio local\n"
 msgid "Cannot get group information for the user\n"
 msgstr "No se pudo obtener la información del grupo del usuario\n"
 
-#: tools/sss_useradd.c:223 tools/sss_userdel.c:229
+#: tools/sss_useradd.c:223
+#: tools/sss_userdel.c:229
 msgid "Cannot set default values\n"
 msgstr "No se pudieron establecer los valores predeterminados\n"
 
-#: tools/sss_useradd.c:230 tools/sss_usermod.c:155
+#: tools/sss_useradd.c:230
+#: tools/sss_usermod.c:155
 msgid "The selected UID is outside the allowed range\n"
 msgstr "El UID seleccionado está fuera del rango permitido\n"
 
-#: tools/sss_useradd.c:257 tools/sss_usermod.c:240
+#: tools/sss_useradd.c:257
+#: tools/sss_usermod.c:240
 msgid "Cannot set SELinux login context\n"
-msgstr ""
+msgstr "No es posible definir contexto de registro de SELinux\n"
 
 #: tools/sss_useradd.c:273
 msgid "Cannot get info about the user\n"
@@ -618,9 +630,7 @@ msgstr "No se pudo obtener información del usuario\n"
 
 #: tools/sss_useradd.c:287
 msgid "User's home directory already exists, not copying data from skeldir\n"
-msgstr ""
-"El directorio de inicio del usuario ya existe, no copiar datos desde el "
-"esqueleto\n"
+msgstr "El directorio de inicio del usuario ya existe, no copiar datos desde el esqueleto\n"
 
 #: tools/sss_useradd.c:290
 #, c-format
@@ -644,7 +654,8 @@ msgstr "Ya existe un usuario o grupo con el mismo nombre o ID\n"
 msgid "Transaction error. Could not add user.\n"
 msgstr "Error en la transacción. No se pudo agregar el usuario.\n"
 
-#: tools/sss_groupadd.c:43 tools/sss_groupmod.c:48
+#: tools/sss_groupadd.c:43
+#: tools/sss_groupmod.c:48
 msgid "The GID of the group"
 msgstr "El GID del grupo"
 
@@ -652,7 +663,8 @@ msgstr "El GID del grupo"
 msgid "Specify group to add\n"
 msgstr "Especifique el grupo a agregar\n"
 
-#: tools/sss_groupadd.c:106 tools/sss_groupmod.c:194
+#: tools/sss_groupadd.c:106
+#: tools/sss_groupmod.c:194
 msgid "The selected GID is outside the allowed range\n"
 msgstr "El GID elegido está fuera del rango permitido\n"
 
@@ -678,12 +690,8 @@ msgid "Group %s is outside the defined ID range for domain\n"
 msgstr "El grupo %s está fuera del rango de ID definido para los dominios\n"
 
 #: tools/sss_groupdel.c:121
-msgid ""
-"No such group in local domain. Removing groups only allowed in local "
-"domain.\n"
-msgstr ""
-"No existe tal grupo en el dominio local. Eliminando los grupos que sólo se "
-"permiten en el dominio local.\n"
+msgid "No such group in local domain. Removing groups only allowed in local domain.\n"
+msgstr "No existe tal grupo en el dominio local. Eliminando los grupos que sólo se permiten en el dominio local.\n"
 
 #: tools/sss_groupdel.c:126
 msgid "Internal error. Could not remove group.\n"
@@ -702,38 +710,29 @@ msgid "Specify group to modify\n"
 msgstr "Especifique el grupo a modificar\n"
 
 #: tools/sss_groupmod.c:130
-msgid ""
-"Cannot find group in local domain, modifying groups is allowed only in local "
-"domain\n"
-msgstr ""
-"No se pudo encontrar el grupo en el dominio local, la modificación de grupos "
-"se permite sólo en el dominio local\n"
+msgid "Cannot find group in local domain, modifying groups is allowed only in local domain\n"
+msgstr "No se pudo encontrar el grupo en el dominio local, la modificación de grupos se permite sólo en el dominio local\n"
 
-#: tools/sss_groupmod.c:151 tools/sss_groupmod.c:178
+#: tools/sss_groupmod.c:151
+#: tools/sss_groupmod.c:178
 msgid "Member groups must be in the same domain as parent group\n"
-msgstr ""
-"Los grupos miembro deben estar en el mismo dominio que el grupo padre\n"
+msgstr "Los grupos miembro deben estar en el mismo dominio que el grupo padre\n"
 
-#: tools/sss_groupmod.c:159 tools/sss_groupmod.c:186 tools/sss_usermod.c:180
+#: tools/sss_groupmod.c:159
+#: tools/sss_groupmod.c:186
+#: tools/sss_usermod.c:180
 #: tools/sss_usermod.c:207
 #, c-format
-msgid ""
-"Cannot find group %s in local domain, only groups in local domain are "
-"allowed\n"
-msgstr ""
-"No se pudo encontrar el grupo %s en el dominio local, solo se permiten los "
-"grupos del dominio local\n"
+msgid "Cannot find group %s in local domain, only groups in local domain are allowed\n"
+msgstr "No se pudo encontrar el grupo %s en el dominio local, solo se permiten los grupos del dominio local\n"
 
 #: tools/sss_groupmod.c:220
 msgid "Could not modify group - check if member group names are correct\n"
-msgstr ""
-"No se pudo modificar el grupo - verifique si los nombre de grupo miembro son "
-"los correctos\n"
+msgstr "No se pudo modificar el grupo - verifique si los nombre de grupo miembro son los correctos\n"
 
 #: tools/sss_groupmod.c:224
 msgid "Could not modify group - check if groupname is correct\n"
-msgstr ""
-"No se pudo modificar el grupo - verifique si el nombre de grupo es correcto\n"
+msgstr "No se pudo modificar el grupo - verifique si el nombre de grupo es correcto\n"
 
 #: tools/sss_groupmod.c:228
 msgid "Transaction error. Could not modify group.\n"
@@ -785,12 +784,8 @@ msgid "Specify group to show\n"
 msgstr "Especifica el grupo a mostrar\n"
 
 #: tools/sss_groupshow.c:698
-msgid ""
-"No such group in local domain. Printing groups only allowed in local "
-"domain.\n"
-msgstr ""
-"No existe tal grupo en el dominio local. Imprimir los grupos está permitido "
-"únicamente en el dominio local.\n"
+msgid "No such group in local domain. Printing groups only allowed in local domain.\n"
+msgstr "No existe tal grupo en el dominio local. Imprimir los grupos está permitido únicamente en el dominio local.\n"
 
 #: tools/sss_groupshow.c:703
 msgid "Internal error. Could not print group.\n"
@@ -810,7 +805,7 @@ msgstr "Forzar la eliminación de los archivos que no pertenecen al usuario"
 
 #: tools/sss_userdel.c:150
 msgid "Kill users' processes before removing him"
-msgstr ""
+msgstr "Finaliza los procesos del usuario antes de eliminarlo"
 
 #: tools/sss_userdel.c:197
 msgid "Specify user to delete\n"
@@ -823,25 +818,25 @@ msgstr "El usuario %s está fuera del rango de ID para el dominio\n"
 
 #: tools/sss_userdel.c:280
 msgid "Cannot reset SELinux login context\n"
-msgstr ""
+msgstr "No es posible reiniciar contexto de registro de SELinux\n"
 
 #: tools/sss_userdel.c:292
 #, c-format
 msgid "WARNING: The user (uid %lu) was still logged in when deleted.\n"
-msgstr ""
+msgstr "ADVERTENCIA: El usuario (uid %lu) todavía se encontraba registrado mientras se lo eliminaba.\n"
 
 #: tools/sss_userdel.c:297
 msgid "Cannot determine if the user was logged in on this platform"
-msgstr ""
+msgstr "No es posible determinar si el usuario estaba registrado en esta plataforma"
 
 #: tools/sss_userdel.c:302
 msgid "Error while checking if the user was logged in\n"
-msgstr ""
+msgstr "Error mientras se verificaba si el usuario se encontraba registrado\n"
 
 #: tools/sss_userdel.c:309
 #, c-format
 msgid "The post-delete command failed: %s\n"
-msgstr ""
+msgstr "Falló el comando de post-eliminación: %s\n"
 
 #: tools/sss_userdel.c:321
 msgid "Not removing home dir - not owned by user\n"
@@ -853,11 +848,8 @@ msgid "Cannot remove homedir: %s\n"
 msgstr " Imposible eliminar el directorio de inicio: %s\n"
 
 #: tools/sss_userdel.c:334
-msgid ""
-"No such user in local domain. Removing users only allowed in local domain.\n"
-msgstr ""
-"No existe ese usuario en el dominio local. La eliminación de usuarios se "
-"permite en el dominio local.\n"
+msgid "No such user in local domain. Removing users only allowed in local domain.\n"
+msgstr "No existe ese usuario en el dominio local. La eliminación de usuarios se permite en el dominio local.\n"
 
 #: tools/sss_userdel.c:339
 msgid "Internal error. Could not remove user.\n"
@@ -888,23 +880,16 @@ msgid "Specify user to modify\n"
 msgstr "Especifique el usuario a modificar\n"
 
 #: tools/sss_usermod.c:148
-msgid ""
-"Cannot find user in local domain, modifying users is allowed only in local "
-"domain\n"
-msgstr ""
-"No se pudo encontrar el usuario en el dominio local, la modificación de los "
-"usuarios se permite solamente en el dominio local\n"
+msgid "Cannot find user in local domain, modifying users is allowed only in local domain\n"
+msgstr "No se pudo encontrar el usuario en el dominio local, la modificación de los usuarios se permite solamente en el dominio local\n"
 
 #: tools/sss_usermod.c:250
 msgid "Could not modify user - check if group names are correct\n"
-msgstr ""
-"No se pudo modificar el usuario - verifique si los nombres de grupo son "
-"correctos\n"
+msgstr "No se pudo modificar el usuario - verifique si los nombres de grupo son correctos\n"
 
 #: tools/sss_usermod.c:254
 msgid "Could not modify user - user already member of groups?\n"
-msgstr ""
-"No se pudo modificar el usuario - ¿no será ya miembro de esos grupos?\n"
+msgstr "No se pudo modificar el usuario - ¿no será ya miembro de esos grupos?\n"
 
 #: tools/sss_usermod.c:258
 msgid "Transaction error. Could not modify user.\n"
@@ -925,6 +910,6 @@ msgstr "Envia el resultado de la depuración hacia archivos en lugar de stderr"
 
 #~ msgid "Cannot initiate search\n"
 #~ msgstr "No es posible iniciar la búsqueda\n"
-
 #~ msgid "Password has expired."
 #~ msgstr "La contraseña ha expirado."
+
-- 
1.7.0.1