>From 6940f1b490ef1123fd2a8992001a9e8e11083f4e Mon Sep 17 00:00:00 2001
From: Pavel Reichl <pavel.reichl@redhat.com>
Date: Tue, 22 Oct 2013 15:21:33 +0100
Subject: [PATCH] Include ext headers with #include <foo.h> - cont

Changing style of including header files from outside of sssd tree - from "header.h" to  <header.h>
---
 src/ldb_modules/memberof.c                              | 3 ++-
 src/providers/krb5/krb5_delayed_online_authentication.c | 2 +-
 src/responder/nss/nsssrv_private.h                      | 2 +-
 src/sbus/sbus_client.h                                  | 2 +-
 src/tests/cmocka/test_find_uid.c                        | 2 +-
 src/tools/sss_debuglevel.c                              | 2 +-
 src/util/find_uid.c                                     | 2 +-
 src/util/find_uid.h                                     | 2 +-
 src/util/server.c                                       | 2 +-
 9 files changed, 10 insertions(+), 9 deletions(-)

diff --git a/src/ldb_modules/memberof.c b/src/ldb_modules/memberof.c
index c26a13bb94bafe62299572565cab4b53c77f3d94..d5f79d4fa1e0a26e7fa1085b9515fece8229493e 100644
--- a/src/ldb_modules/memberof.c
+++ b/src/ldb_modules/memberof.c
@@ -18,9 +18,10 @@
 */
 
 #include <string.h>
+#include <dhash.h>
+
 #include "ldb_module.h"
 #include "util/util.h"
-#include "dhash.h"
 
 #define DB_MEMBER "member"
 #define DB_GHOST "ghost"
diff --git a/src/providers/krb5/krb5_delayed_online_authentication.c b/src/providers/krb5/krb5_delayed_online_authentication.c
index 46ed6f65c7ad97c47db57cfe97b33e6dd7e3b074..3518cb7d1762769eb914c0c69c91a785aaf1c06d 100644
--- a/src/providers/krb5/krb5_delayed_online_authentication.c
+++ b/src/providers/krb5/krb5_delayed_online_authentication.c
@@ -27,9 +27,9 @@
 #include <sys/types.h>
 #include <keyutils.h>
 #endif
+#include <dhash.h>
 
 #include "providers/krb5/krb5_auth.h"
-#include "dhash.h"
 #include "util/util.h"
 #include "util/find_uid.h"
 
diff --git a/src/responder/nss/nsssrv_private.h b/src/responder/nss/nsssrv_private.h
index 04f1330c69531128ed0ac21f85e6ce02542549de..c1d6b119c6982188102446badc808bb89e6148f9 100644
--- a/src/responder/nss/nsssrv_private.h
+++ b/src/responder/nss/nsssrv_private.h
@@ -25,7 +25,7 @@
 #ifndef NSSSRV_PRIVATE_H_
 #define NSSSRV_PRIVATE_H_
 
-#include "dhash.h"
+#include <dhash.h>
 
 struct nss_cmd_ctx {
     struct cli_ctx *cctx;
diff --git a/src/sbus/sbus_client.h b/src/sbus/sbus_client.h
index 742f8a10c3516232dec77808ef2daf9bc191745c..ff322e451ee87fd035f4648054fd3913c2a76bd2 100644
--- a/src/sbus/sbus_client.h
+++ b/src/sbus/sbus_client.h
@@ -22,7 +22,7 @@
 #ifndef SBUS_CLIENT_H_
 #define SBUS_CLIENT_H_
 
-#include "tevent.h"
+#include <tevent.h>
 #include "sbus/sssd_dbus.h"
 
 int sbus_client_init(TALLOC_CTX *mem_ctx,
diff --git a/src/tests/cmocka/test_find_uid.c b/src/tests/cmocka/test_find_uid.c
index d4837be0da2d33f9a15e12036171ce5cbd7a8f70..dcc367962bbd7a9a16643c79f08c856cc8635f2f 100644
--- a/src/tests/cmocka/test_find_uid.c
+++ b/src/tests/cmocka/test_find_uid.c
@@ -29,10 +29,10 @@
 #include <unistd.h>
 #include <sys/types.h>
 #include <cmocka.h>
+#include <dhash.h>
 
 #include "util/find_uid.h"
 #include "tests/common.h"
-#include "dhash.h"
 
 void test_check_if_uid_is_active_success(void **state)
 {
diff --git a/src/tools/sss_debuglevel.c b/src/tools/sss_debuglevel.c
index 3fe634e84c6f9fa102c5bbd85968e2cece34d6c0..de9c8ac65f0e84665e9cc7c5a2fed57f17c0b591 100644
--- a/src/tools/sss_debuglevel.c
+++ b/src/tools/sss_debuglevel.c
@@ -28,9 +28,9 @@
 #include <ctype.h>
 #include <signal.h>
 #include <utime.h>
+#include <ldb.h>
 
 #include "config.h"
-#include "ldb.h"
 #include "util/util.h"
 #include "tools/tools_util.h"
 #include "confdb/confdb.h"
diff --git a/src/util/find_uid.c b/src/util/find_uid.c
index 6d1478e7f85bf420be6707c9eda0fa45b88a74be..91ee7f6853dde4d7f6e8196dd0d31a8833af096e 100644
--- a/src/util/find_uid.c
+++ b/src/util/find_uid.c
@@ -35,8 +35,8 @@
 #include <talloc.h>
 #include <ctype.h>
 #include <sys/time.h>
+#include <dhash.h>
 
-#include "dhash.h"
 #include "util/find_uid.h"
 #include "util/util.h"
 #include "util/strtonum.h"
diff --git a/src/util/find_uid.h b/src/util/find_uid.h
index 154a5f955dad90f59d3c4949295a4b863cd1a106..e01b3fce390a0733e28beffb214eea95e98d2c09 100644
--- a/src/util/find_uid.h
+++ b/src/util/find_uid.h
@@ -26,8 +26,8 @@
 
 #include <talloc.h>
 #include <sys/types.h>
+#include <dhash.h>
 
-#include "dhash.h"
 #include "util/util.h"
 
 errno_t get_uid_table(TALLOC_CTX *mem_ctx, hash_table_t **table);
diff --git a/src/util/server.c b/src/util/server.c
index b1c59e1d7dfcf911539e50b6783561e7284538b5..c1a9644a1fa71dd1456217b204206eca3744b4cd 100644
--- a/src/util/server.c
+++ b/src/util/server.c
@@ -28,8 +28,8 @@
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <unistd.h>
+#include <ldb.h>
 #include "util/util.h"
-#include "ldb.h"
 #include "confdb/confdb.h"
 #include "monitor/monitor_interfaces.h"
 
-- 
1.8.3.1